
// Vk3DVision (http://3dsurroundgaming.com/) - Original Shader
#version 450
#extension GL_EXT_nonuniform_qualifier : require
#extension GL_ARB_shader_draw_parameters : require
#extension GL_ARB_shader_ballot : require

out float gl_ClipDistance[1];

invariant gl_Position;

struct S_MATRICES
{
    mat4 _mModelViewProj;
    mat4 _mModelViewProjPrevious;
    mat4 _mModelView;
    mat4 _mInvModelView;
};

struct unaligned_float3
{
    float x;
    float y;
    float z;
};

struct S_TBN
{
    int _iNormal;
    int _iTangent;
};

struct S_INDICES
{
    uint _uiObjectIndex;
    uint _uiMaterialIndex;
    uint _uiMaterialInstanceIndex;
    uint _uiLastFrameMaterialIndex;
    uint _uiLastFrameMaterialInstanceIndex;
    uint _uiPositionsBufferIndex;
    uint _uiPrevPositionsBufferIndex;
    uint _uiNormalsBufferIndex;
    uint _uiPositionOffset;
    uint _uiPrevPositionOffset;
    uint _uiNormalOffset;
    uint _uiMatricesIndex;
};

struct S_MAIN_DEFAULT
{
    S_INDICES _Indices;
};

struct S_MAIN_DEFAULT_ARRAY
{
    S_MAIN_DEFAULT _aMain[32];
};

struct S_MESH_OBJECT
{
    mat4 _mModel;
    mat4 _mModelLast;
    mat4 _mInvModel;
    mat4 _mInvModelLast;
    vec4 _vDiversityOffset;
    uint _uiSceneZoneIndex;
    uint _uiNeighborSceneZoneIndex;
    uint _uiDisplayFlags;
    uint _uiPackedLocalExposureCompensation;
    vec4 _vPortalDirAndDistance;
    int _iPickingID[2];
    float _fLocalExposureCompensation;
    float _fLocalExposureCompensationEV100;
};

struct S_MATERIAL
{
    vec4 _vErrorColor;
    float _fDepthBias;
    float _fDummy0;
    float _fDummy1;
    float _fDummy2;
    float c0;
    float c1;
    float c2;
    float c3;
    uint s0;
    uint s1;
    uint s2;
    uint s3;
    uint s4;
    uint s5;
    uint s6;
    uint s7;
    uint s8;
    uint s9;
    uint s10;
    uint s11;
};

struct S_MATERIAL_INSTANCE
{
    float c0;
    float c1;
    float c2;
    float c3;
    float c4;
    float c5;
    float c6;
    float c7;
    float _fGloubiboulga;
};

struct S_PASS_MATRICES
{
    mat4 _mViewJitteredProj;
    mat4 _mViewProj;
    mat4 _mView;
    mat4 _mInvView;
    mat4 _mJitteredProj;
};

struct S_EYE_DATA
{
    S_PASS_MATRICES _mCurrentFrameMatrices[2];
    S_PASS_MATRICES _mPreviousFrameMatrices[2];
    mat4 _mJitteredProjection[2];
    mat4 _mNoJitterProjection[2];
    mat4 _mInvViewJitteredProj[2];
    vec4 _vWorldSpaceCameraVector[2];
    vec4 _vWorldSpaceCameraPosition[2];
    vec4 _vFrameBufferScale;
    vec4 _vFrameBufferViewportSize;
    vec4 _vFrameBufferOneOnViewportSize;
    vec4 _vViewportSize;
    vec4 _vFogSubCrop;
    uint _uiAlignment0;
    uint _uiAlignment1;
    float _vCameraJitterDeltaX;
    float _vCameraJitterDeltaY;
    vec4 _vfRcpFVolumetricFogDepthTileSize;
};

struct S_CASCADED_SHADOW
{
    mat4 _mCascadeMatrix[2][8];
    mat4 _mViewSpaceToStaticShadowMapSpace[2];
    vec4 _vfCascadeShadowAttenuation;
    vec4 _vfShadowCascadeTextureTexelSize;
    vec4 _vfStaticShadowBlurRadius;
    vec4 _vfCascadeLinearZProjFactors[8];
    vec4 _vfCascadeParams[8];
};

struct S_CLUSTER_LIGHT_SETUP
{
    S_CASCADED_SHADOW _CascadedShadow;
    vec4 _vfSkinUVParamsAndNormalBias;
    vec4 _vfShadowTextureTexelSize;
    vec4 _vfDummy_SkinFresnelF0AndF90;
    uint _uiCascadedUsed;
    float _fSSSWidth;
    float _fOffsetBias;
    float _fDummy;
};

struct S_CLUSTER_INFO
{
    mat4 _mViewToClusterView[2];
    mat4 _mClusterProjMatrix;
    mat4 _mClusterInvProjMatrix;
    vec4 _vfLeftEyeToCombinedEyeVsDeltaXZ;
    uint _uiFinestMipWidth;
    uint _uiFinestMipHeight;
    uint _uiFinestMipDepth;
    uint _uiFinestMipWidthHeight;
    float _fZSliceGeomFactor;
    float _fRcpLogZSliceGeomFactor;
    float _fDummy0;
    float _fDummy1;
    float _fNearP;
    float _fInvNearP;
    float _fFarP;
    float _fClusterCoincidentWithCamera;
};

struct S_PASS
{
    S_EYE_DATA _EyeData;
    vec4 _avFrustumCorners[4];
    vec4 _vTime;
    vec4 _cFogColor;
    vec4 _vFogSetup;
    vec4 _cSunColor;
    vec4 _vSunDir;
    vec4 _vProjectionSetup;
    vec4 _vProjectionCoeff;
    vec4 _vOutputColor;
    vec4 _vfVsClippingPlane[2];
    S_CLUSTER_LIGHT_SETUP _LightSetup;
    S_CLUSTER_INFO _ClusterInfo;
    float _fIBLIntensity;
    float _fGIIntensity;
    float _fAmbiantOcclusionDirectIntensity;
    float _fAmbiantOcclusionIndirectIntensity;
    float _fNormalSign;
    int _iFogType;
    float _fSelfOcclusionDebugRatio;
    float _fEmissive;
    int _iEnableSkinSSSSS;
    int _iUseHairOpaquePrepass;
    float _fLocalSceneExposure;
    uint _uiDebugMode;
    uint _sFlags;
    float _fTAADropsSharpness;
    uint _uNeoScaleX;
    uint _uNeoScaleY;
    uint _uiDirectOverdrawFilter;
    float _fCoderTest0;
    float _fCoderTest1;
    float _fCoderTest2;
    uint _uiBakeOutput;
    float _fDefaultAmbientIntensity;
    float _fDefaultLightingIntensity;
    uint _uiOutputColor;
    float _fAARotation;
    float _fClampDirectSpecular;
    float _fNearPlane;
    float _fFarPlane;
    float _fNDFFilteringScreenSpaceVariance;
    float _fNDFFilteringThreshold;
    float _fNDFFilteringScreenSpaceVariance_EyeShader;
    float _fNDFFilteringThreshold_EyeShader;
    float _fSurfaceGradientTextureFiltering;
    float _fZero;
    uint _uDepthClamp;
    uint _uiLightDebugMode;
    vec4 _vfFragCoordToDepthTexFactor;
    vec4 _vfFragCoordToDepthTexFactor_HalfRes;
    uint _uHdr;
    uint _uiDrawMayaSwatch;
    float _fEyeRoughnessBias;
    float _fDummy1;
};

layout(set = 1, binding = 24, std430) readonly buffer stc_g_rbMatrices_Layout
{
    S_MATRICES g_rbMatrices[];
} _165;

layout(set = 1, binding = 39, std430) readonly buffer g_rbVertices_Layout
{
    unaligned_float3 g_rbVertices[];
} g_rbVertices_Buffer[];

layout(set = 1, binding = 40, std430) readonly buffer g_rbTBNs_Layout
{
    S_TBN g_rbTBNs[];
} g_rbTBNs_Buffer[];

layout(set = 0, binding = 52, std140) uniform dyn_CONSTANT_BUFFER_BLOCK_CB_S_MAIN_ARRAY_BINDING
{
    S_MAIN_DEFAULT_ARRAY g_cbMainArray;
} _1118;

layout(set = 1, binding = 33, std430) readonly buffer g_rbObjects_Layout
{
    S_MESH_OBJECT g_rbObjects[];
} g_rbObjects_Buffer[];

layout(set = 1, binding = 34, std430) readonly buffer g_rbMaterials_Layout
{
    S_MATERIAL g_rbMaterials[];
} g_rbMaterials_Buffer[];

layout(set = 1, binding = 35, std430) readonly buffer g_rbMaterialInstances_Layout
{
    S_MATERIAL_INSTANCE g_rbMaterialInstances[];
} g_rbMaterialInstances_Buffer[];

layout(set = 2, binding = 53, std140) uniform dyn_CONSTANT_BUFFER_BLOCK_CB_S_PASS_BINDING
{
    S_PASS g_cbPass;
} _1379;

layout(set = 1, binding = 12) uniform sampler2D g_rb2DTextures[];

layout(location = 8) in vec2 in_uv0;
layout(location = 23) out float interp_instanceID;

vec3 _7954;

void main()
{
    int _1108 = gl_InstanceIndex + gl_DrawIDARB;
    int _1109 = readFirstInvocationARB(_1108);
    uint _3045 = uint(gl_VertexIndex);
    uint _3048 = _3045 + _1118.g_cbMainArray._aMain[_1109]._Indices._uiPositionOffset;
    vec4 _3061 = vec4(g_rbVertices_Buffer[_1118.g_cbMainArray._aMain[_1109]._Indices._uiPositionsBufferIndex].g_rbVertices[_3048].x, g_rbVertices_Buffer[_1118.g_cbMainArray._aMain[_1109]._Indices._uiPositionsBufferIndex].g_rbVertices[_3048].y, g_rbVertices_Buffer[_1118.g_cbMainArray._aMain[_1109]._Indices._uiPositionsBufferIndex].g_rbVertices[_3048].z, 1.0);
    uint _3068 = _3045 + _1118.g_cbMainArray._aMain[_1109]._Indices._uiNormalOffset;
    int _3097 = g_rbTBNs_Buffer[_1118.g_cbMainArray._aMain[_1109]._Indices._uiNormalsBufferIndex].g_rbTBNs[_3068]._iNormal & 1023;
    int _3100 = (g_rbTBNs_Buffer[_1118.g_cbMainArray._aMain[_1109]._Indices._uiNormalsBufferIndex].g_rbTBNs[_3068]._iNormal >> 10) & 1023;
    int _3103 = (g_rbTBNs_Buffer[_1118.g_cbMainArray._aMain[_1109]._Indices._uiNormalsBufferIndex].g_rbTBNs[_3068]._iNormal >> 20) & 1023;
    int _7941;
    if (_3097 > 512)
    {
        _7941 = _3097 | (-1024);
    }
    else
    {
        _7941 = _3097;
    }
    int _7943;
    if (_3100 > 512)
    {
        _7943 = _3100 | (-1024);
    }
    else
    {
        _7943 = _3100;
    }
    int _7945;
    if (_3103 > 512)
    {
        _7945 = _3103 | (-1024);
    }
    else
    {
        _7945 = _3103;
    }
    float _3146 = float(_7941);
    float _3149 = float(_7943);
    float _3152 = float(_7945);
    vec3 _3153 = vec3(_3146, _3149, _3152);
    vec3 _3156 = _3153 * vec3(0.001956947147846221923828125);
    vec3 _3246 = _3061.xyz;
    mat3 _3438 = mat3(g_rbObjects_Buffer[_1118.g_cbMainArray._aMain[_1109]._Indices._uiObjectIndex].g_rbObjects[0]._mModel[0].xyz, g_rbObjects_Buffer[_1118.g_cbMainArray._aMain[_1109]._Indices._uiObjectIndex].g_rbObjects[0]._mModel[1].xyz, g_rbObjects_Buffer[_1118.g_cbMainArray._aMain[_1109]._Indices._uiObjectIndex].g_rbObjects[0]._mModel[2].xyz);
    vec3 _3441 = _3438 * _3156;
    vec2 _3645 = in_uv0 * vec2(2.0);
    vec3 _7887 = _7954;
    _7887.y = textureLod(g_rb2DTextures[g_rbMaterials_Buffer[_1118.g_cbMainArray._aMain[_1109]._Indices._uiMaterialIndex].g_rbMaterials[0].s0], _3645 + vec2(-0.0500000007450580596923828125, -0.190476000308990478515625), 0.0).x;
    vec3 _3663 = vec3(g_rbMaterialInstances_Buffer[_1118.g_cbMainArray._aMain[_1109]._Indices._uiMaterialInstanceIndex].g_rbMaterialInstances[0].c0);
    vec3 _3666 = mod(_3663, vec3(2.0));
    vec3 _3670 = _7887 * _3666;
    vec3 _7896 = _7954;
    _7896.y = textureLod(g_rb2DTextures[g_rbMaterials_Buffer[_1118.g_cbMainArray._aMain[_1109]._Indices._uiMaterialIndex].g_rbMaterials[0].s0], (in_uv0 * vec2(3.0)) + vec2(-0.20000000298023223876953125, -2.099999904632568359375), 0.0).y;
    vec3 _3700 = _3663 * vec3(0.100000001490116119384765625);
    vec3 _3703 = floor(_3700);
    vec3 _3707 = mod(_3703, vec3(2.0));
    vec3 _3711 = _7896 * _3707;
    vec3 _3715 = vec3(1.0) - _3670;
    vec3 _3718 = vec3(1.0) - _3711;
    vec3 _3719 = _3715 * _3718;
    vec3 _7905 = _7954;
    _7905.y = textureLod(g_rb2DTextures[g_rbMaterials_Buffer[_1118.g_cbMainArray._aMain[_1109]._Indices._uiMaterialIndex].g_rbMaterials[0].s0], _3645 + vec2(-0.3540000021457672119140625, 0.20000000298023223876953125), 0.0).z;
    vec3 _3751 = _3663 * vec3(0.00999999977648258209228515625);
    vec3 _3754 = floor(_3751);
    vec3 _3758 = mod(_3754, vec3(2.0));
    vec3 _3762 = _7905 * _3758;
    vec3 _3769 = vec3(1.0) - _3762;
    vec3 _3770 = _3719 * _3769;
    vec3 _3772 = vec3(1.0) - _3770;
    float _3774 = _3772.y;
    float _3779 = _3774 - 0.949999988079071044921875;
    float _3784 = _3779 * 19.9959964752197265625;
    float _3785 = clamp(_3784, 0.0, 1.0);
    float _3786 = mix(0.0, 1.0, _3785);
    float _3794 = _3774 - 0.88999998569488525390625;
    float _3799 = _3794 * 99.90019989013671875;
    float _3800 = clamp(_3799, 0.0, 1.0);
    float _3801 = mix(0.0, 1.0, _3800);
    vec3 _3806 = vec3(_3801);
    vec3 _3807 = mix(vec3(0.0), vec3(-0.011610000394284725189208984375), _3806);
    vec3 _3812 = vec3(_3786);
    vec3 _3813 = mix(_3807, vec3(-0.019349999725818634033203125), _3812);
    vec3 _3819 = _3813 * _3441;
    vec3 _3827 = vec3(g_rbMaterialInstances_Buffer[_1118.g_cbMainArray._aMain[_1109]._Indices._uiMaterialInstanceIndex].g_rbMaterialInstances[0].c1);
    vec3 _3828 = mix(vec3(0.0), _3819, _3827);
    vec3 _3852 = _3246 + _3828;
    float _3978 = _3852.x;
    float _3979 = _3852.y;
    float _3980 = _3852.z;
    vec4 _3981 = vec4(_3978, _3979, _3980, 1.0);
    vec4 _3982 = _165.g_rbMatrices[_1118.g_cbMainArray._aMain[_1109]._Indices._uiMatricesIndex]._mModelView * _3981;
    vec4 _4001 = _165.g_rbMatrices[_1118.g_cbMainArray._aMain[_1109]._Indices._uiMatricesIndex]._mModelViewProj * _3981;
    vec4 _7951;
    if (_1379.g_cbPass._uDepthClamp == 4294967295u)
    {
        float _4035 = _4001.w;
        vec4 _7952;
        if ((_4001.z / _4035) > 1.0)
        {
            vec4 _7953;
            if (_3982.z > _1379.g_cbPass._fNearPlane)
            {
                vec4 _7918 = _4001;
                _7918.z = _4035;
                _7953 = _7918;
            }
            else
            {
                _7953 = _4001;
            }
            _7952 = _7953;
        }
        else
        {
            _7952 = _4001;
        }
        _7951 = _7952;
    }
    else
    {
        _7951 = _4001;
    }
    interp_instanceID = float(_1108) + 0.5;
    float _2931 = _3982.x;
    float _2932 = _3982.y;
    float _2933 = _3982.z;
    vec4 _2934 = vec4(_2931, _2932, _2933, 1.0);
    float _2935 = dot(_1379.g_cbPass._vfVsClippingPlane[0], _2934);
    float _2936 = -_2935;
    gl_ClipDistance[0] = _2936;
    gl_Position = _7951;
}

